<h1 align="center">programming-challenges</h1>

<p align="center">
  <strong>Programming exercises and challenges to improve your algorithmic logic.</strong>
</p>

<p align="center">
  <a href="https://gitpod.io/#https://github.com/Divlo/programming-challenges"><img src="https://img.shields.io/badge/Gitpod-ready--to--code-blue?logo=gitpod" alt="Gitpod ready-to-code"/></a>
  <a href="./LICENSE"><img src="https://img.shields.io/badge/licence-MIT-blue.svg" alt="Licence MIT"/></a>
  <a href="http://makeapullrequest.com"><img src="https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square" alt="PRs Welcome"/></a>
  <br/> <br/>
  <img src="./logo.png" width="120" alt="programming-challenges Logo" />
</p>

## 📜 About

**programming-challenges** brings together lots of programming exercises and challenges to improve your algorithmic logic.

Each challenge has its **solutions**, its **instructions** and **input/output examples** so you can try to solve them on your own. See [challenges](./challenges) folder.

### ✅ Programming languages available

- [C/C++ (gcc)](https://gcc.gnu.org/)
- [C# (.NET Core)](https://docs.microsoft.com/en-us/dotnet/csharp/)
- [Dart](https://dart.dev/)
- [JavaScript/TypeScript (Node.js)](https://nodejs.org/)
- [Python](https://www.python.org/)
- [Rust](https://www.rust-lang.org/)

## 🚀 Getting Started

### ☁️ Try with a Single-Click

Gitpod will automatically setup an environment for you.

[![Open in Gitpod](https://gitpod.io/button/open-in-gitpod.svg)](https://gitpod.io/#https://github.com/Divlo/programming-challenges)

### Locally

#### Prerequisites

- [Node.js](https://nodejs.org/) >= 16
- [npm](https://npmjs.com/) >= 7
- [Docker](https://www.docker.com/)

#### Installation

```sh
# Clone the repository
git clone https://github.com/Divlo/programming-challenges.git

# Go to the project root
cd programming-challenges

# Install dependencies
npm install

# Install the `programming-challenges` Command Line Interface (CLI)
npm install --global
```

### Usage

```sh
# Discover all the commands availables
programming-challenges --help
```

## 💡 Contributing

Anyone can help to improve the project, submit a challenge, a solution or even correct a simple spelling mistake.

The steps to contribute can be found in the [CONTRIBUTING.md](./CONTRIBUTING.md) file.

## 📄 License

[MIT](./LICENSE)
